<template>
    <div class="prolongation-block-all">
        <div class="warning-block-prolongation">
            <div class="warning-icon-prolongation"></div>
            <!-- + new Date().addHours(12).toLocaleString('ru-RU')-->
            <div class="text-for-warning-block">{{ textForWarningBlock }} <b>{{dateOverProlongation}}</b></div>
        </div>
        <label>Код из СМС: </label>

        <input type="tel"
               ref="smsCode"
               maxlength="4"
               v-model="prolongationSmsCode"
               v-validate="'required|min:4'"
               v-mask="'####'"
               class="prolongation-sms-code"
               name="sms-код для подтверждения допсоглашения"
               :class="getValidateClass('sms-код для подтверждения допсоглашения')"
               autocomplete="off"
        >

        <button class="blue"
                :disabled="!agree || $store.getters.getButtonLoading"
                @click="postSmsCode"
                :class="{button_loading: $store.getters.getButtonLoading}"
        >
            Подписать
        </button>

        <div>
            <validate-message
                    v-show="vErrors.has('sms-код для подтверждения допсоглашения')">
                {{ vErrors.first('sms-код для подтверждения допсоглашения') }}
            </validate-message>
        </div>

        <!--timer-->
        <div class="row">
            <a v-if="callBack" class="refresh-code-prolongation">Выслать код повторно через {{backTime}}
                {{$helpers.plural(backTime, ['секунду', 'секунды', 'секунд'])}}</a>
            <a v-else @click="againSms" class="refresh-code-prolongation after-time">Выслать код повторно</a>
        </div>

        <!--timer-->
        <div class="row" style="margin-top: 15px">
            <div class="warning-block-text-with-phone">
                <div class="padding ui-checkbox" style="padding:0;">
                    <ui-checkbox v-model="agree"></ui-checkbox>

                    <p @click="agree = !agree">
                        Вводя код подтверждения, вы принимаете
                        <a class="text-decoration"
                           @click.prevent.stop="getSupplementary">условия
                            доп. соглашения
                        </a>
                    </p>

                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import {LOANS_UPDATE_CURRENT_PDL} from '@/store/mutation-types'
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import RangeSlider from '@/components/RangeSlider'
    import {errorProlongation} from '@/utils/error/prolongation'
    import smsErrors from '@/utils/error_mapper/smsErrors';

    export default {
        name: 'SmsForm',

        mixins: [
            ErrorHandleMixin,
            GetValidateClass
        ],

        components: {
            RangeSlider,
        },

        data() {
            return {
                textForWarningBlock: 'Доп.соглашение сформировано, необходимо подписать до ',
                prolongationSmsCode: '',
                agree: true,
                callBack: false,
                backTime: 60,
            }
        },

        computed: {
            dateOverProlongation() {
                const supplementary = this.$pdl.supplementary;
                if(supplementary) {
                    const amnesty2019 = supplementary.amnesty2019;
                    if(amnesty2019) {
                        const signDateEnd = amnesty2019.signDateEnd;
                        if(signDateEnd) {
                            return this.$dayjs(signDateEnd).format('DD.MM.YYYY (HH:mm)')
                        }
                    }
                }
                return '';
            },
        },

        methods: {

            async postSmsCode() {
                if (!this.agree) {
                    this.$toastr.error('Вы должны принять условия доп. соглашения', 'Ошибка')
                    return
                }
                this.$store.commit('AJAX_LOADING', true);
                this.$backend.postData('supplementary/amnesty-2019/sign', {
                    smsCode: Number(this.prolongationSmsCode)
                }).then(async () => {
                    this.$toastr.success('Доп.соглашение успешно подписано. ', 'Успешно');
                    // после подписания нужно обновить пдл
                    this.$store.dispatch('GET_LOAN_PDL').then(() => {
                      this.$emit('success');
                    });
                    this.$backend.log({
                      lk_stats: 'amnesty_2019',
                      action: 'sing',
                      user_id: this.$user.id,
                      pdl_id: this.$pdl.id
                    });

                }).catch((e) => {
                    this.$error(e, smsErrors, 'Ошибка подписания доп.соглашения.');
                }).finally(() => {
                    this.$store.commit('AJAX_LOADING', false)
                })
            },

            againSms() {
              this.callBack = true;
              this.tiktak();
              this.$backend.getData('supplementary/amnesty-2019/sign/resend').then(() => {
                this.$toastr.success('Код подтверждения отправлен повторно', 'Успешно');
              }).catch((error) => {
                this.$error(error, smsErrors, 'Ошибка подписания доп.соглашения.');
              })
            },

            tiktak () {
                if (!this.backTime) {
                    this.callBack = false
                    this.backTime = 60
                    return false
                }
                this.callBack = true
                setTimeout(() => {
                    this.backTime--;
                    this.tiktak();
                }, 1000)
            },

            async getSupplementary() {
                const win = window.open('about:blank', 'target=_blank', 'status=0,title=0,height=600,width=1000,scrollbars=1');
                await this.$backend.getData(`documents/supplementary/html/${this.$pdl.id}/${this.$pdl.supplementary.amnesty2019.id}`).then(res => {
                    win.document.write(res.data)
                })
            },

        }

    }
</script>


<style scoped lang="scss">

</style>